/*=================================================================================
	lib_eeprom.c
-----------------------------------------------------------------------------------
	EEPROMɃANZX邽߂̊{vO

	EEPROM̃AhX => x[XAhX(8rbg)+ItZbgAhX(16rbg)
	EEPROM̃AhX͈̔ => 0x7FFC00 ` 0x7FFFFF
	1[h16rbg

	NbN\[X	Fosc = 7.37[MHz] :dsPIC̓NbNgp
	VXeNbNFsy  = 7.37 * 8 = 58.96[MHz] :PLLx8gp
	߃NbN	Fcy  = 58.96 / 4 = 14.74[MHz]
=================================================================================*/
#include <p30f5011.h>	//TBLPAG̓@\WX^gp邽߂ɌĂяo

register unsigned int offset asm("w0");	//ϐoffsetw0Ɋ蓖Ă
register unsigned int *pt asm("w8");	//ϐptw8Ɋ蓖Ă
register unsigned int dat asm("w9");	//ϐdatw9Ɋ蓖Ă

int eeprom_erase(unsigned int adr)
{
	TBLPAG = 0x7F;			//x[XAhX
	NVMADR = adr;			//NVMADRɃItZbgli[
							//EEPROMAhX=0x7F0000+adr
	NVMCON = 0x4044;		//1[h

	asm("PUSH SR");			//Xe[^XWX^ޔ
	SR = ((SR & 0xff1f) | 0x00e0);	//MPU荞ݗDx7ɐݒ


	asm("MOV #0x55,W0");	//KEYV[PXiEݑOɕKsj
	asm("MOV W0,NVMKEY");
	asm("MOV #0xAA,W0");
	asm("MOV W0,NVMKEY");
	asm("BSET NVMCON,#15");	//Jn

	asm("POP SR");
	while(NVMCON&0x8000);	//I܂Ń[v

	return 0;
}

int eeprom_erase_16(unsigned int adr)
{
	TBLPAG = 0x7F;			//x[XAhX
	NVMADR = adr;			//NVMADRɃItZbgli[
							//EEPROMAhX=0x7F0000+adr
	NVMCON = 0x4045;		//16[h

	asm("PUSH SR");			//Xe[^XWX^ޔ
	SR = ((SR & 0xff1f) | 0x00e0);	//MPU荞ݗDx7ɐݒ

	asm("MOV #0x55,W0");	//KEYV[PXiEݑOɕKsj
	asm("MOV W0,NVMKEY");
	asm("MOV #0xAA,W0");
	asm("MOV W0,NVMKEY");
	asm("BSET NVMCON,#15");	//Jn

	asm("POP SR");
	while(NVMCON&0x8000);	//I܂Ń[v

	return 0;
}

int eeprom_wr(unsigned int adr,unsigned int data)
{
	dat = data;				//W9<-data

	TBLPAG = 0x7F;			//x[XAhX
	offset = adr;			//W0ɃItZbgli[
							//EEPROMAhX=0x7F0000+adr
	asm("TBLWTL w9,[W0]");	//[EEPROMAhX]<-w9

	NVMCON = 0x4004;		//1[h

	asm("PUSH SR");			//Xe[^XWX^ޔ
	SR = ((SR & 0xff1f) | 0x00e0);	//MPU荞ݗDx7ɐݒ

	asm("MOV #0x55,W0");	//KEYV[PXiEݑOɕKsj
	asm("MOV W0,NVMKEY");
	asm("MOV #0xAA,W0");
	asm("MOV W0,NVMKEY");
	asm("BSET NVMCON,#15");	//݊Jn

	asm("POP SR");
	while(NVMCON&0x8000);	//ݏI܂Ń[v

	return 0;
}

int eeprom_wr_16(unsigned int adr,unsigned int *data)
{
	pt = data;						//W8<-data

	TBLPAG = 0x7F;					//x[XAhX
	offset = adr;					//W0ɃItZbgli[
									//EEPROMAhX=0x7F0000+adr
	asm("TBLWTL [w8++],[W0++]");	//[EEPROMAhX]<-[data]
	asm("TBLWTL [w8++],[W0++]");
	asm("TBLWTL [w8++],[W0++]");
	asm("TBLWTL [w8++],[W0++]");
	asm("TBLWTL [w8++],[W0++]");
	asm("TBLWTL [w8++],[W0++]");
	asm("TBLWTL [w8++],[W0++]");
	asm("TBLWTL [w8++],[W0++]");
	asm("TBLWTL [w8++],[W0++]");
	asm("TBLWTL [w8++],[W0++]");
	asm("TBLWTL [w8++],[W0++]");
	asm("TBLWTL [w8++],[W0++]");
	asm("TBLWTL [w8++],[W0++]");
	asm("TBLWTL [w8++],[W0++]");
	asm("TBLWTL [w8++],[W0++]");
	asm("TBLWTL [w8++],[W0++]");

	NVMCON = 0x4005;				//16[h

	asm("PUSH SR");					//Xe[^XWX^ޔ
	SR = ((SR & 0xff1f) | 0x00e0);	//MPU荞ݗDx7ɐݒ

	asm("MOV #0x55,W0");			//KEYV[PXiEݑOɕKsj
	asm("MOV W0,NVMKEY");
	asm("MOV #0xAA,W0");
	asm("MOV W0,NVMKEY");
	asm("BSET NVMCON,#15");			//݊Jn

	asm("POP SR");
	while(NVMCON&0x8000);			//ݏI܂Ń[v

	return 0;
}

int eeprom_rd(unsigned int adr,unsigned int *data)
{
	TBLPAG = 0x7F;			//x[XAhX
	offset = adr;			//W0ɃItZbgli[
							//EEPROMAhX=0x7F0000+adr
	asm("TBLRDL [W0],W9");	//w9<-[EEPROMAhX]
	*data = dat;			//[data]<-w9

	return 0;
}

int eeprom_rd_16(unsigned int adr,unsigned int *data)
{
	pt = data;						//W8<-data

	TBLPAG = 0x7F;					//x[XAhX
	offset = adr;					//W0ɃItZbgli[
									//EEPROMAhX=0x7F0000+adr
	asm("TBLRDL [W0++],[w8++]");	//[data]<-[EEPROMAhX]
	asm("TBLRDL [W0++],[w8++]");
	asm("TBLRDL [W0++],[w8++]");
	asm("TBLRDL [W0++],[w8++]");
	asm("TBLRDL [W0++],[w8++]");
	asm("TBLRDL [W0++],[w8++]");
	asm("TBLRDL [W0++],[w8++]");
	asm("TBLRDL [W0++],[w8++]");
	asm("TBLRDL [W0++],[w8++]");
	asm("TBLRDL [W0++],[w8++]");
	asm("TBLRDL [W0++],[w8++]");
	asm("TBLRDL [W0++],[w8++]");
	asm("TBLRDL [W0++],[w8++]");
	asm("TBLRDL [W0++],[w8++]");
	asm("TBLRDL [W0++],[w8++]");
	asm("TBLRDL [W0++],[w8++]");

	return 0;
}
